require("XGUI_Lib")
require ("lxp")
require("timezones")
require("tables")

local ListingsURL="http://www.aztv.co.il/site/XmlFiles/createTvProgr.hx.asp"

local curchannelid
local channelid
local curtime
local cgrabber

local function StartElement (parser, name, attrs)
local pid,width
local program
if name=="channel" then
	channelid=attrs["id"]
	elseif (name=="program")and(channelid==curchannelid)and(attrs["id"]~="") then
		program=XGUI.GetProgram(cgrabber,attrs["id"]) or {}
		program.Title=attrs["title"]
		program.Channel=channelid
		program.ID=attrs["id"]
		if attrs["st"]=="1" then
			program.Start=table.copy(curtime)
			program.Start.Hour=program.Start.Hour-2
			program.Start=time.Fix(program.Start)
			end
		curtime.Minute=curtime.Minute+math.floor(attrs["width"]*2/5)
		curtime=time.Fix(curtime)
		--if attrs["en"]=="1" then
			program.Stop=table.copy(curtime)
			program.Stop.Hour=program.Stop.Hour-2
			program.Stop=time.Fix(program.Stop)
			--end
		XGUI.AddProgram(cgrabber,program)
		end
end

local function Pass1Func(grabber,channel,ctime)
	XGUI.SetStatus(2,"Downloading "..string.format("%s - %.2d/%.2d %.2d:%.2d",XGUI_Lib.XS.Val(channel.Name),ctime.Day,ctime.Month,ctime.Hour,ctime.Minute));
	local datestr=string.format("%.2d_%.2d_%.2d_%.2d",ctime.Day,ctime.Month,ctime.Hour,ctime.Minute)
	local page,err
	page,err=XGUI.Post(ListingsURL,
		'<?xml version=\"1.0\" encoding=\"Windows-1255\"?><data><date>'..datestr..'</date><otv/></data>',
		grabber,
		_,_,
		datestr..".xml",1)
	if (err<400)and(err~=-1) then
		page=string.gsub(page,"encoding=\"Windows%-1255\"","encoding=\"UTF-8\"")
		page=Win1255ToUTF8(page)
		local callbacks = {
			StartElement = StartElement,
			}
		curchannelid=channel.ID
		curtime=ctime
		cgrabber=grabber
		local lx = lxp.new(callbacks)
		local res,msg, line, col, pos
		res,msg, line, col, pos=lx:parse(page)
		if not res then
			print(string.format("Parse error on line %d, column %s: \"%s\"",line,col,msg))
			end
		res,msg, line, col, pos=lx:parse()
		if not res then
			print(string.format("Parse error on line %d, column %s: \"%s\"",line,col,msg))
			end
		lx:close()
		return XGUI.OK
		end
	return XGUI.Fail
	end

local function Pass1End(grabber)
	print("Clearing cache")
	XGUI.CleanCache(grabber,1);
	return XGUI.OK
	end
		
local function Init(grabber)
	XGUI.AddSetting(grabber,"IgnoreTBA",XGUI.SettingType.Boolean,"true","Ignore TBA Programs")
	XGUI.AddSetting(grabber,"UseCache",XGUI.SettingType.Boolean,"true","Use Cache")
	return XGUI.OK
	end
	
Grabbers.IL_AZ={
	Name = "Israel - AZTV.co.il",
	Version = "1.00.00",
	Author = "Alan Birtles",
	InfoURL = "http://www.birtles.org.uk/xmltv",
	SourceURL = "http://www.aztv.co.il/site/programs/programs.asp?start=now",
	Encoding = XGUI.Encoding.UTF8,
	Passes={
		Pass1={
			Type=XGUI.PassTypes.ChannelTime,
			Func=Pass1Func,
			End=Pass1End,
			MaxDays=7,
			Interval=180,
			},
		},
	RefreshChannels=RefChans,
	Init=Init,
	}
